﻿#region [ Modification History ]
/*
 * 07/9/2013 Denis Kholine
 *  Add license and description.
 */
#endregion

#region  [ UIUC NCSA Open Source License ]
/*****************************************************************************\
 *             University of Illinois/NCSA Open Source License
 *
 * 
 *      Copyright © 2012,2013, The Board of Trustees of the University of Illinois. All rights reserved.
 *
 *      Developed by: Rakesh Bobba, Derek Dagit, Erich Heine, Denis Kholine,
 *                    Klara Nahrstedt, David Rodgers,   William H. Sanders, Tim Yardley
 *
 *      Information Trust Institute/Coordinated Science Laboratory
 * 
 *      University of Illinois
 *      
 *      The Board of Trustees of the University of Illinois
 *      109 Coble Hall
 *      801 South Wright Street
 *      Champaign, IL 61820-6242
 *
 *      http://www.iti.illinois.edu / http://csl.illinois.edu
 * 
 *      Permission is hereby granted, free of charge, to any person obtaining a copy of this software and 
 *      associated documentation files (the “Software”), to deal with the Software without restriction, 
 *      including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense,
 *      and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so,
 *      subject to the following conditions:
 *
 *      Redistributions of source code must retain the above copyright notice, this list of conditions and the
 *      following disclaimers.
 *      
 *      Redistributions in binary form must reproduce the above copyright notice, this list of conditions and
 *      the following disclaimers in the documentation and/or other materials provided with the distribution.
 *
 *      Neither the names of Information Trust institute, Coordinated Science Laboratory, University of Illinois,
 *      The Board of Trustees of the University of Illinois nor the names of its contributors may be used to 
 *      endorse or promote products derived from this Software without specific prior written permission.
 *      
 *      THE SOFTWARE IS PROVIDED “AS IS”, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT
 *      LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN
 *      NO EVENT SHALL THE CONTRIBUTORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 *      WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE 
 *      SOFTWARE OR THE USE OR OTHER DEALINGS WITH THE SOFTWARE.
 *      
 \*****************************************************************************/
#endregion

#region [ Using ]
using System;
using System.Data;
using System.Linq;
using System.Diagnostics;
using SIEGate.Core;
using SIEGate.Core.Logging;
using SIEGate.Core.Fakes;
using SIEGate.Core.Notifications;
using SIEGate.Core.MessageBusses;
using SIEGate.Core.Configurator;
using System.Collections.Generic;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using GSF;
using GSF.TimeSeries.Transport;
using GSF.ServiceProcess;
#endregion

namespace SIEGateCoreTest.Logging
{
    /// <summary>
    /// ServiceHelperLogger tests
    /// </summary>
    [TestClass]
    public class ServiceHelperLoggerTests
    {

        #region [ Members ]
        private ServiceHelper helper;
        private ServiceHelperLogger target;
        #endregion

        #region [ Methods ]
        /// <summary>
        /// ServiceHelperLogger Constructor test
        /// </summary>
        [TestMethod]
        public void ConstructorTest()
        {
            bool expected = true;
            bool actual = false;
            helper = new ServiceHelper();
            try
            {
                target = new ServiceHelperLogger(helper);
                actual = true;
            }
            catch
            {
                actual = false;
            }
            Assert.AreEqual(expected, actual);
            Assert.IsInstanceOfType(target, typeof(ServiceHelperLogger));
            Assert.IsNotNull(target);
        }

        /// <summary>
        /// Log test
        /// TODO: helperlogger message declared as private.
        /// </summary>
        [TestMethod]
        public void LogTest()
        {
            LogLevel level = LogLevel.Debug;
            DateTime time=new DateTime();
            string source = "SIEGate";
            string tag = "UnitTests";
            string message = "test";
            helper = new ServiceHelper();
            target = new ServiceHelperLogger(helper);
            bool expected = true;
            bool actual = false;
            try
            {
                target.Log(level, time, source, tag, message);
                actual = true;
            }
            catch
            {
            }
            Assert.AreEqual(expected, actual);
            
         
        }
        #endregion
    }
}
